//******************************************************************************
//  E-154.
//      
//      
//******************************************************************************
program TtlInLines;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows, Lusbapi;

var
	//   E-154
	pModule : ILE154;
	//   Rtusbapi.dll
	DllVersion : DWORD;
	//  
	ModuleHandle : THandle;
	//  
	ModuleName: AnsiString;
	//    USB
	UsbSpeed : BYTE;
	//      
	ModuleDescription : MODULE_DESCRIPTION_E154;

	// ***   ***
	i : WORD;
	//    
   TtlIn: WORD;
	//      - 
	InputConsoleHandle : THandle;
	//      - 
	OutputConsoleHandle : THandle;
	//     
	MaxX, MaxY : DWORD;
 	//  
	Str : AnsiString;


//------------------------------------------------------------------------------
//    /
//------------------------------------------------------------------------------
procedure InitConsoleHandles;
var
	Coord : TCoord;  //  /  
begin
	//       - 
	InputConsoleHandle := GetStdHandle(STD_INPUT_HANDLE);
	//       - 
	OutputConsoleHandle := GetStdHandle(STD_OUTPUT_HANDLE);
	//    
	Coord := GetLargestConsoleWindowSize(OutputConsoleHandle);
	MaxX := Coord.X;
	MaxY := Coord.Y;
end;

//------------------------------------------------------------------------------
//     ESCAPE
//------------------------------------------------------------------------------
function IsEscKeyPressed : boolean;
var
	Buffer: INPUT_RECORD;
	Count: DWORD;

begin
	Result := false;
	GetNumberOfConsoleInputEvents(InputConsoleHandle, Count);
	if Count > 0 then
		begin
			ReadConsoleInput(InputConsoleHandle, Buffer, 1, Count);
			case Buffer.EventType of
				KEY_EVENT:
					case Buffer.Event.KeyEvent.wVirtualKeyCode of
	            VK_ESCAPE: Result := true;
            //  
          end;
       //   
      end;
    end;
end;

//------------------------------------------------------------------------------
//     X, Y
//------------------------------------------------------------------------------
procedure GotoXY(X, Y : Word);
var
	Coord : TCoord;  //  /  
begin
	Coord.X := X; Coord.Y := Y;
	SetConsoleCursorPosition(OutputConsoleHandle, Coord);
end;

//------------------------------------------------------------------------------
//   -   
//------------------------------------------------------------------------------
procedure ClearScreen;
var
	Coord : TCoord;	//  /  
	NOAW  : DWORD;		//     
begin
	Coord.X := 0; Coord.Y := 0;
	FillConsoleOutputCharacter(OutputConsoleHandle, ' ', MaxX*MaxY, Coord, NOAW);
	GotoXY(0, 0);
end;

//------------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------
procedure AbortProgram(ErrorString: AnsiString; AbortionFlag : bool = true);
begin
	//   
	if pModule <> nil then
		begin
			//   
			if not pModule.ReleaseLInstance() then  WriteLn(' ReleaseLInstance() --> Bad')
			else WriteLn(' ReleaseLInstance() --> OK');
			//     
			pModule := nil;
		end;

	//   -    
	if ErrorString <> ' ' then MessageBox(HWND(nil), pAnsiChar(ErrorString), '!!!', MB_OK + MB_ICONINFORMATION);
	//   -   
	if AbortionFlag = true then halt;
end;

//******************************************************************************
//					  	                   
//******************************************************************************
begin
	//     
	InitConsoleHandles();
	//   
	ClearScreen();

	//    DLL 
	DllVersion := GetDllVersion;
	if DllVersion <> CURRENT_VERSION_LUSBAPI then
		begin
			Str := '  DLL  Lusbapi.dll! ' + #10#13 +
						'           : ' + IntToStr(DllVersion shr 16) +  '.' + IntToStr(DllVersion and $FFFF) + '.' +
						' : ' + IntToStr(CURRENT_VERSION_LUSBAPI shr 16) + '.' + IntToStr(CURRENT_VERSION_LUSBAPI and $FFFF) + '.';
			AbortProgram(Str);
		end
	else WriteLn(' DLL Version --> OK');

	//        E-154
	pModule := CreateLInstance(pAnsiChar('e154'));
	if pModule = nil then AbortProgram('     E-154!')
	else WriteLn(' Module Interface --> OK');

	//    E-154   MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI  
	for i := 0 to (MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI-1) do if pModule.OpenLDevice(i) then break;
	// - ?
	if i = MAX_VIRTUAL_SLOTS_QUANTITY_LUSBAPI then AbortProgram('    E-154   127  !')
	else WriteLn(Format(' OpenLDevice(%u) --> OK', [i]));

	//   
	ModuleHandle := pModule.GetModuleHandle();
	if ModuleHandle = INVALID_HANDLE_VALUE then AbortProgram('    !')
	else WriteLn(' GetModuleHandle() --> OK');

	//       
	ModuleName := '0123456789';
	if not pModule.GetModuleName(pAnsiChar(ModuleName)) then AbortProgram('    !')
	else WriteLn(' GetModuleName() --> OK');
	// ,    E-154
	if not Boolean(AnsiCompareStr(ModuleName, pAnsiChar('E154'))) then AbortProgram('    E-154!')
	else WriteLn(' The module is ''E-154''');

	//      USB
	if not pModule.GetUsbSpeed(@UsbSpeed) then AbortProgram('       USB')
	else WriteLn(' GetUsbSpeed() --> OK\n');
	//      USB
	if UsbSpeed = USB11_LUSBAPI then Str := 'Full-Speed Mode (12 Mbit/s)'
	else Str := 'High-Speed Mode (480 Mbit/s)';
	WriteLn(Format('   USB is in %s', [Str]));

	//       DSP
	if not pModule.GET_MODULE_DESCRIPTION(@ModuleDescription) then AbortProgram('     !')
	else WriteLn(' GET_MODULE_DESCRIPTION() --> OK');

	//          
	WriteLn('');
	Write  (' Module E-154 (S/N ', StrPas(@ModuleDescription.Module.SerialNumber)); WriteLn(') is ready ... ');
	WriteLn('   Module Info:');
	WriteLn(Format('     Module  Revision   is ''%1.1s''', [StrPas(@ModuleDescription.Module.Revision)]));
	WriteLn(Format('     MCU Driver Version is %s (%s)', [StrPas(@ModuleDescription.Mcu.Version.Version), StrPas(@ModuleDescription.Mcu.Version.Date)]));
	//   
	Write(#10#13);

	//     TTL_IN().
	WriteLn(#10#13' You can press ESC key to terminate the program...'#10#13);
	while true do
	   begin
			//       
			if not pModule.TTL_IN(@TtlIn) then begin WriteLn(#10#13' TtlIn() -> Bad!'); break; end
			//       ESC
			else if IsEscKeyPressed() then break;
			//     
			Write(Format(' TtlIn Lines State is 0x%4.4x'#13, [TtlIn]));
			//          
			Sleep(50);

		end;

	//   
	Write(#10#13#10#13);

	//       
	AbortProgram(' ', false);
	//  
	exit;
end.
